diff --git a/src/main/java/net/minecraft/core/achievement/Achievements.java b/src/main/java/net/minecraft/core/achievement/Achievements.java
index cc6c6de70..f6448eaab 100644
--- a/src/main/java/net/minecraft/core/achievement/Achievements.java
+++ b/src/main/java/net/minecraft/core/achievement/Achievements.java
@@ -12,10 +12,6 @@ public abstract class Achievements
 {
     
     public static List<Achievement> achievementList = new ArrayList<>();
-    public static int minX;
-    public static int minY;
-    public static int maxX;
-    public static int maxY;
     public static Achievement OPEN_INVENTORY =
         new Achievement(new NamespaceID("minecraft", "open_inventory"), "openInventory", 0, 0, Items.BOOK, null)
         .setClientsideAchievement().registerAchievement()
@@ -23,15 +19,15 @@ public abstract class Achievements
     public static Achievement MINE_WOOD =
         new Achievement(new NamespaceID("minecraft", "mine_wood"), "mineWood", 2, 1, Blocks.LOG_OAK, OPEN_INVENTORY)
             .registerAchievement()
-            .addToPage(AchievementPages.overworldPage, AchievementPages.netherPage);
+            .addToPage(AchievementPages.overworldPage);
     public static Achievement BUILD_WORKBENCH =
         new Achievement(new NamespaceID("minecraft", "build_workbench"), "buildWorkBench", 4, -1, Blocks.WORKBENCH, MINE_WOOD)
             .registerAchievement()
-            .addToPage(AchievementPages.overworldPage, AchievementPages.netherPage);
+            .addToPage(AchievementPages.overworldPage);
     public static Achievement BUILD_PICKAXE =
         new Achievement(new NamespaceID("minecraft", "build_pickaxe"), "buildPickaxe", 4, 2, Items.TOOL_PICKAXE_WOOD, BUILD_WORKBENCH)
             .registerAchievement()
-            .addToPage(AchievementPages.overworldPage, AchievementPages.netherPage);
+            .addToPage(AchievementPages.overworldPage);
     public static Achievement BUILD_FURNACE =
         new Achievement(new NamespaceID("minecraft", "build_furnace"), "buildFurnace", 3, 4, Blocks.FURNACE_STONE_ACTIVE, BUILD_PICKAXE)
             .registerAchievement()
@@ -40,16 +36,29 @@ public abstract class Achievements
         new Achievement(new NamespaceID("minecraft", "acquire_iron"), "acquireIron", 1, 4, Items.INGOT_IRON, BUILD_FURNACE)
             .registerAchievement()
             .addToPage(AchievementPages.overworldPage);
+    public static Achievement GET_DIAMONDS =
+        new Achievement(new NamespaceID("minecraft", "get_diamonds"), "getDiamonds", -1, 4, Items.DIAMOND, ACQUIRE_IRON)
+            .setType(Achievement.TYPE_SPECIAL)
+            .registerAchievement()
+            .addToPage(AchievementPages.overworldPage);
     public static Achievement BUILD_HOE =
-        new Achievement(new NamespaceID("minecraft", "build_hoe"), "buildHoe", 2, -3, Items.TOOL_HOE_WOOD, BUILD_WORKBENCH)
+        new Achievement(new NamespaceID("minecraft", "build_hoe"), "buildHoe", 1, -3, Items.TOOL_HOE_WOOD, BUILD_WORKBENCH)
             .registerAchievement()
             .addToPage(AchievementPages.overworldPage);
     public static Achievement MAKE_BREAD =
-        new Achievement(new NamespaceID("minecraft", "make_bread"), "makeBread", -1, -3, Items.FOOD_BREAD, BUILD_HOE)
+        new Achievement(new NamespaceID("minecraft", "make_bread"), "makeBread", -2, -3, Items.FOOD_BREAD, BUILD_HOE)
             .registerAchievement()
             .addToPage(AchievementPages.overworldPage);
     public static Achievement BAKE_CAKE =
-        new Achievement(new NamespaceID("minecraft", "bake_cake"), "bakeCake", 0, -5, Items.FOOD_CAKE, BUILD_HOE)
+        new Achievement(new NamespaceID("minecraft", "bake_cake"), "bakeCake", -1, -5, Items.FOOD_CAKE, BUILD_HOE)
+            .registerAchievement()
+            .addToPage(AchievementPages.overworldPage);
+    public static Achievement CRAFT_ICECREAM =
+        new Achievement(new NamespaceID("minecraft", "craft_icecream"), "craftIcecream", 1, -6, Items.BUCKET_ICECREAM, BUILD_HOE)
+            .registerAchievement()
+            .addToPage(AchievementPages.overworldPage);
+    public static Achievement CRAFT_PUMPKIN_PIE =
+        new Achievement(new NamespaceID("minecraft", "craft_pumpkin_pie"), "craftPumpkinPie", -1, -1, Items.FOOD_PUMPKIN_PIE, BUILD_HOE)
             .registerAchievement()
             .addToPage(AchievementPages.overworldPage);
     public static Achievement BUILD_BETTER_PICKAXE =
@@ -69,6 +78,11 @@ public abstract class Achievements
         new Achievement(new NamespaceID("minecraft", "build_sword"), "buildSword", 6, -1, Items.TOOL_SWORD_WOOD, BUILD_WORKBENCH)
             .registerAchievement()
             .addToPage(AchievementPages.overworldPage);
+    public static Achievement ALL_ARMOR_TYPES =
+        new Achievement(new NamespaceID("minecraft", "all_armor_types"), "allArmorTypes", 13, 1, Items.ARMOR_CHESTPLATE_STEEL, null)
+            .setType(Achievement.TYPE_SPECIAL)
+            .registerAchievement()
+            .addToPage(AchievementPages.overworldPage);
     public static Achievement KILL_ENEMY =
         new Achievement(new NamespaceID("minecraft", "kill_enemy"), "killEnemy", 8, -1, Items.BONE, BUILD_SWORD)
             .registerAchievement()
@@ -83,7 +97,7 @@ public abstract class Achievements
             .registerAchievement()
             .addToPage(AchievementPages.overworldPage);
     public static Achievement GET_SENSED =
-        new Achievement(new NamespaceID("minecraft", "get_sensed"), "getSensed", 10, -1, Blocks.MOTION_SENSOR_ACTIVE, KILL_ENEMY)
+        new Achievement(new NamespaceID("minecraft", "get_sensed"), "getSensed", 9, -3, Blocks.MOTION_SENSOR_ACTIVE, KILL_ENEMY)
             .registerAchievement()
             .addToPage(AchievementPages.overworldPage);
     public static Achievement CRAFT_HANDCANNON =
@@ -100,11 +114,11 @@ public abstract class Achievements
             .registerAchievement()
             .addToPage(AchievementPages.overworldPage);
     public static Achievement REPAIR_ARMOR =
-        new Achievement(new NamespaceID("minecraft", "repair_armor"), "repairArmor", 12, -1, Items.CHAINLINK, GET_SENSED)
+        new Achievement(new NamespaceID("minecraft", "repair_armor"), "repairArmor", 9, 0, Items.CHAINLINK, KILL_ENEMY)
             .registerAchievement()
             .addToPage(AchievementPages.overworldPage);
     public static Achievement GET_CHAINMAIL =
-        new Achievement(new NamespaceID("minecraft", "get_chainmail"), "getChainmail", 14, -1, Items.ARMOR_HELMET_CHAINMAIL, REPAIR_ARMOR)
+        new Achievement(new NamespaceID("minecraft", "get_chainmail"), "getChainmail", 11, 0, Items.ARMOR_HELMET_CHAINMAIL, REPAIR_ARMOR)
             .setType(Achievement.TYPE_SPECIAL)
             .registerAchievement()
             .addToPage(AchievementPages.overworldPage);
@@ -118,6 +132,70 @@ public abstract class Achievements
             .setType(Achievement.TYPE_SPECIAL)
             .registerAchievement()
             .addToPage(AchievementPages.overworldPage);
+    public static Achievement ALL_MUSIC_DISCS =
+        new Achievement(new NamespaceID("minecraft", "all_music_discs"), "allMusicDiscs", -3, 4, Items.RECORD_STAL, null)
+            .setType(Achievement.TYPE_SPECIAL)
+            .registerAchievement()
+            .addToPage(AchievementPages.overworldPage);
+    public static Achievement TRIPLE_HIT =
+        new Achievement(new NamespaceID("minecraft", "triple_hit"), "tripleHit", 11, -2, Items.AMMO_ARROW_GOLD, KILL_ENEMY)
+            .setType(Achievement.TYPE_SPECIAL)
+            .registerAchievement()
+            .addToPage(AchievementPages.overworldPage);
+
+
+    // Nether achievements
+    public static Achievement ENTER_NETHER =
+        new Achievement(new NamespaceID("minecraft", "enter_nether"), "enterNether", 2, 0, Blocks.OBSIDIAN, null)
+            .setType(Achievement.TYPE_SPECIAL)
+            .registerAchievement()
+            .addToPage(AchievementPages.netherPage);
+    public static Achievement GET_NETHERCOAL =
+        new Achievement(new NamespaceID("minecraft", "get_nethercoal"), "getNethercoal", 1, 2, Items.NETHERCOAL, ENTER_NETHER)
+            .setType(Achievement.TYPE_NORMAL)
+            .registerAchievement()
+            .addToPage(AchievementPages.netherPage);
+    public static Achievement LIGHT_SIGN =
+        new Achievement(new NamespaceID("minecraft", "light_sign"), "lightSign", 4, 0, Items.DUST_GLOWSTONE, ENTER_NETHER)
+            .setType(Achievement.TYPE_NORMAL)
+            .registerAchievement()
+            .addToPage(AchievementPages.netherPage);
+    public static Achievement SWIM_NETHER =
+        new Achievement(new NamespaceID("minecraft", "swim_nether"), "swimNether", 3, 2, Blocks.ICE, ENTER_NETHER)
+            .setType(Achievement.TYPE_SPECIAL)
+            .registerAchievement()
+            .addToPage(AchievementPages.netherPage);
+    public static Achievement HIT_FIREBALL =
+        new Achievement(new NamespaceID("minecraft", "hit_fireball"), "hitFireball", 3, -2, Items.AMMO_FIREBALL, ENTER_NETHER)
+            .setType(Achievement.TYPE_SPECIAL)
+            .registerAchievement()
+            .addToPage(AchievementPages.netherPage);
+    public static Achievement SLEEP_NETHER =
+        new Achievement(new NamespaceID("minecraft", "sleep_nether"), "sleepNether", 1, -2, Items.BED, ENTER_NETHER)
+            .setType(Achievement.TYPE_SPECIAL)
+            .registerAchievement()
+            .addToPage(AchievementPages.netherPage);
+    public static Achievement ENTER_OLDWORLD =
+        new Achievement(new NamespaceID("minecraft", "enter_oldworld"), "enterOldworld", 0, -5, Blocks.BEDROCK, ENTER_NETHER)
+            .setType(Achievement.TYPE_NORMAL)
+            .registerAchievement()
+            .addToPage(AchievementPages.netherPage);
+    public static Achievement ENTER_WARRENS =
+        new Achievement(new NamespaceID("minecraft", "enter_warrens"), "enterWarrens", 0, 5, Blocks.BEDROCK, ENTER_NETHER)
+            .setType(Achievement.TYPE_NORMAL)
+            .registerAchievement()
+            .addToPage(AchievementPages.netherPage);
+    public static Achievement MOST_WANTED =
+        new Achievement(new NamespaceID("minecraft", "most_wanted"), "mostWanted", -0, -1, Items.TOOL_SWORD_GOLD, ENTER_NETHER)
+            .setType(Achievement.TYPE_NORMAL)
+            .registerAchievement()
+            .addToPage(AchievementPages.netherPage);
+    public static Achievement FAST_TRAVEL = // TODO
+        new Achievement(new NamespaceID("minecraft", "fast_travel"), "fastTravel", -0, 1, Blocks.GRASS, ENTER_NETHER)
+            .setType(Achievement.TYPE_NORMAL)
+            .registerAchievement()
+            .addToPage(AchievementPages.netherPage);
+
 
     private static boolean hasInit = false;
     public static void init() {
diff --git a/src/main/java/net/minecraft/core/block/BedBlock.java b/src/main/java/net/minecraft/core/block/BedBlock.java
index 93c9b0e86..1dd845d5e 100644
--- a/src/main/java/net/minecraft/core/block/BedBlock.java
+++ b/src/main/java/net/minecraft/core/block/BedBlock.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.block;
 
+import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.player.Player;
@@ -46,6 +47,7 @@ public class BedBlock extends Block {
 			if(world.getBlockId(x, y, z) == id) {
 				world.setBlockWithNotify(x, y, z, 0);
             }
+			player.addStat(Achievements.SLEEP_NETHER, 1);
 			world.newExplosion(null, (float) x + 0.5F, (float) y + 0.5F, (float) z + 0.5F, 5F, true, false);
 			return true;
 		}
diff --git a/src/main/java/net/minecraft/core/block/DispenserBlock.java b/src/main/java/net/minecraft/core/block/DispenserBlock.java
index 7a0d721cd..a6e680913 100644
--- a/src/main/java/net/minecraft/core/block/DispenserBlock.java
+++ b/src/main/java/net/minecraft/core/block/DispenserBlock.java
@@ -125,7 +125,7 @@ public class DispenserBlock extends RotatableEntityBlock
             else if (itemStack.itemID == Items.AMMO_ARROW.id || itemStack.itemID == Items.AMMO_ARROW_GOLD.id)
             {
 
-                ArrowProjectile arrow = itemStack.itemID == Items.AMMO_ARROW.id ? new ArrowProjectile(world, px, py, pz, 0) : new ArrowProjectileGolden(world, px, py, pz);
+                ArrowProjectile arrow = itemStack.itemID == Items.AMMO_ARROW.id ? new ArrowProjectile(world, px, py, pz, 0) : new GoldenArrowProjectile(world, px, py, pz);
                 arrow.setHeading(xOffset, 0.1D, zOffset, 1.1F, 6F);
                 arrow.setDoesArrowBelongToPlayer(true);
                 world.entityJoinedWorld(arrow);
diff --git a/src/main/java/net/minecraft/core/block/SignBlock.java b/src/main/java/net/minecraft/core/block/SignBlock.java
index cdcb84b7c..2557be6f6 100644
--- a/src/main/java/net/minecraft/core/block/SignBlock.java
+++ b/src/main/java/net/minecraft/core/block/SignBlock.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.block;
 
+import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.entity.SignBlockEntity;
 import net.minecraft.core.entity.player.Player;
@@ -163,6 +164,7 @@ public class SignBlock extends EntityBlock
                 if (player.getGamemode().consumeBlocks()) {
                     player.getHeldItem().stackSize--;
                 }
+                player.addStat(Achievements.LIGHT_SIGN, 1);
                 return true;
             } else if (player.getHeldItem() != null && player.getHeldItem().itemID == Items.DYE.id) {
                 return false;
diff --git a/src/main/java/net/minecraft/core/block/StoneBlock.java b/src/main/java/net/minecraft/core/block/StoneBlock.java
index 8b005717c..0b34f12fc 100644
--- a/src/main/java/net/minecraft/core/block/StoneBlock.java
+++ b/src/main/java/net/minecraft/core/block/StoneBlock.java
@@ -31,9 +31,13 @@ public class StoneBlock extends Block {
 	public void harvestBlock(World world, Player player, int x, int y, int z, int meta, BlockEntity blockEntity)
 	{
 		super.harvestBlock(world, player, x, y, z, meta, blockEntity);
-		if(player.getStat(Blocks.BASALT.getStat(StatList.STAT_MINED)) > 0
-				&& player.getStat(Blocks.BASALT.getStat(StatList.STAT_MINED)) > 0
-				&& player.getStat(Blocks.BASALT.getStat(StatList.STAT_MINED)) > 0) {
+		if(
+			player.getStat(Blocks.STONE.getStat(StatList.STAT_MINED)) > 0 &&
+			player.getStat(Blocks.BASALT.getStat(StatList.STAT_MINED)) > 0 &&
+			player.getStat(Blocks.GRANITE.getStat(StatList.STAT_MINED)) > 0 &&
+			player.getStat(Blocks.LIMESTONE.getStat(StatList.STAT_MINED)) > 0 &&
+			player.getStat(Blocks.PERMAFROST.getStat(StatList.STAT_MINED)) > 0) {
+
 			player.triggerAchievement(Achievements.COLLECT_STONE);
 		}
 	}
diff --git a/src/main/java/net/minecraft/core/entity/EntityDispatcher.java b/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
index f50e6a645..d33dc2a93 100644
--- a/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
+++ b/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
@@ -136,9 +136,9 @@ public class EntityDispatcher
         addMapping(MinecartEntity.class, "Minecart", 40);
         addMapping(BoatEntity.class, "Boat", 41);
         addMapping(ZombieArmoredMob.class, "ArmouredZombie", 42);
-        addMapping(ArrowProjectileGolden.class, "ArrowGolden", 43);
+        addMapping(GoldenArrowProjectile.class, "ArrowGolden", 43);
         addMapping(CannonballProjectile.class, "Cannonball", 44);
-        addMapping(ArrowProjectilePurple.class, "ArrowPurple", 45);
+        addMapping(PurpleArrowProjectile.class, "ArrowPurple", 45);
         addMapping(PebbleProjectile.class, "Pebble", 46);
         addMapping(FireflyClusterMob.class, "FireflyCluster", 47);
         addMapping(Mob.class, "Mob", 48);
diff --git a/src/main/java/net/minecraft/core/entity/ItemEntity.java b/src/main/java/net/minecraft/core/entity/ItemEntity.java
index a4394a968..3fc5b2ac2 100644
--- a/src/main/java/net/minecraft/core/entity/ItemEntity.java
+++ b/src/main/java/net/minecraft/core/entity/ItemEntity.java
@@ -19,6 +19,7 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.MusicDiscItem;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.AABB;
@@ -214,6 +215,12 @@ public class ItemEntity extends Entity
 				if(item.itemID == Items.LEATHER.id) {
 					player.triggerAchievement(Achievements.KILL_COW);
 				}
+                if(item.itemID == Items.DIAMOND.id) {
+                    player.triggerAchievement(Achievements.GET_DIAMONDS);
+                }
+                if(item.itemID == Items.NETHERCOAL.id) {
+                    player.triggerAchievement(Achievements.GET_NETHERCOAL);
+                }
 				if(item.itemID == Blocks.ICE.id) {
 					player.triggerAchievement(Achievements.CRUSH_BLOCKS);
 				}
@@ -235,6 +242,24 @@ public class ItemEntity extends Entity
 					}
 				}
 
+                if (item.getItem() instanceof MusicDiscItem) {
+                    if( player.getStat(Items.RECORD_13.getStat(StatList.STAT_PICKED_UP)) > 0 &&
+                        player.getStat(Items.RECORD_CAT.getStat(StatList.STAT_PICKED_UP)) > 0 &&
+                        player.getStat(Items.RECORD_BLOCKS.getStat(StatList.STAT_PICKED_UP)) > 0 &&
+                        player.getStat(Items.RECORD_CHIRP.getStat(StatList.STAT_PICKED_UP)) > 0 &&
+                        player.getStat(Items.RECORD_FAR.getStat(StatList.STAT_PICKED_UP)) > 0 &&
+                        player.getStat(Items.RECORD_MALL.getStat(StatList.STAT_PICKED_UP)) > 0 &&
+                        player.getStat(Items.RECORD_MELLOHI.getStat(StatList.STAT_PICKED_UP)) > 0 &&
+                        player.getStat(Items.RECORD_STAL.getStat(StatList.STAT_PICKED_UP)) > 0 &&
+                        player.getStat(Items.RECORD_STRAD.getStat(StatList.STAT_PICKED_UP)) > 0 &&
+                        player.getStat(Items.RECORD_WARD.getStat(StatList.STAT_PICKED_UP)) > 0 &&
+                        player.getStat(Items.RECORD_WAIT.getStat(StatList.STAT_PICKED_UP)) > 0 &&
+                        player.getStat(Items.RECORD_DOG.getStat(StatList.STAT_PICKED_UP)) > 0)
+                    {
+                        player.triggerAchievement(Achievements.ALL_MUSIC_DISCS);
+                    }
+                }
+
 				if(item.stackSize <= 0) {
 					remove();
 				}
diff --git a/src/main/java/net/minecraft/core/entity/monster/ZombiePigMob.java b/src/main/java/net/minecraft/core/entity/monster/ZombiePigMob.java
index 5d33fbc47..92627d569 100644
--- a/src/main/java/net/minecraft/core/entity/monster/ZombiePigMob.java
+++ b/src/main/java/net/minecraft/core/entity/monster/ZombiePigMob.java
@@ -1,6 +1,8 @@
 package net.minecraft.core.entity.monster;
 
 import net.minecraft.core.WeightedRandomLootObject;
+import net.minecraft.core.achievement.Achievement;
+import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Items;
@@ -37,6 +39,18 @@ public class ZombiePigMob extends ZombieMob
     @Override
 	public void tick()
     {
+        if (tickCount % 200 == 0 && entityToAttack instanceof Player && ((Player) entityToAttack).getStat(Achievements.MOST_WANTED) <= 0) {
+            int agroNumber = 1;
+            for (Entity e : world.loadedEntityList) {
+                if (e instanceof ZombiePigMob && ((ZombiePigMob) e).entityToAttack == this.entityToAttack) {
+                    agroNumber++;
+                }
+                if (agroNumber >= 20) {
+                    ((Player) entityToAttack).addStat(Achievements.MOST_WANTED, 1);
+                    break;
+                }
+            }
+        }
         moveSpeed = entityToAttack == null ? 0.5F : 0.95F;
         if(randomSoundDelay > 0 && --randomSoundDelay == 0)
         {
diff --git a/src/main/java/net/minecraft/core/entity/player/Player.java b/src/main/java/net/minecraft/core/entity/player/Player.java
index 9f0485ba7..0abe40af6 100644
--- a/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -36,7 +36,7 @@ import net.minecraft.core.entity.monster.SnowmanMob;
 import net.minecraft.core.entity.monster.SpiderMob;
 import net.minecraft.core.entity.monster.ZombieMob;
 import net.minecraft.core.entity.projectile.ArrowProjectile;
-import net.minecraft.core.entity.projectile.ArrowProjectileGolden;
+import net.minecraft.core.entity.projectile.GoldenArrowProjectile;
 import net.minecraft.core.entity.projectile.CannonballProjectile;
 import net.minecraft.core.entity.projectile.FireballProjectile;
 import net.minecraft.core.entity.vehicle.BoatEntity;
@@ -59,6 +59,7 @@ import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.core.world.chunk.provider.IChunkProvider;
@@ -91,6 +92,7 @@ public abstract class Player extends Mob
     public double zd0;
     protected boolean sleeping;
     public ChunkCoordinates bedChunkCoordinates;
+    public ChunkCoordinates dimensionEnterCoordinate;
     private int sleepTimer;
     public float sleepOffX;
     public float sleepOffY;
@@ -189,6 +191,16 @@ public abstract class Player extends Mob
     @Override
 	public void tick()
     {
+        if (world.dimension == Dimension.nether) {
+            if (y >= 260) {
+                addStat(Achievements.ENTER_OLDWORLD, 1);
+            } else if (y >=128) {
+                addStat(Achievements.ENTER_NETHER, 1);
+            } else {
+                addStat(Achievements.ENTER_WARRENS, 1);
+            }
+        }
+
         xdO = xd;
         ydO = yd;
         zd0 = zd;
@@ -460,11 +472,11 @@ public abstract class Player extends Mob
         {
             return getDisplayName() + deathMsgColor + " got what they deserved.";
         }
-        if (entityKilledBy instanceof ArrowProjectileGolden)
+        if (entityKilledBy instanceof GoldenArrowProjectile)
         {
-            if (((ArrowProjectileGolden) entityKilledBy).owner instanceof ServerPlayer)
+            if (((GoldenArrowProjectile) entityKilledBy).owner instanceof ServerPlayer)
             {
-                if (((ServerPlayer) ((ArrowProjectileGolden) entityKilledBy).owner).username.equals(username))
+                if (((ServerPlayer) ((GoldenArrowProjectile) entityKilledBy).owner).username.equals(username))
                 {
                     return getDisplayName() + deathMsgColor + " got gold in their eye.";
                 }
@@ -1322,6 +1334,9 @@ public abstract class Player extends Mob
             if(j > 0)
             {
                 addStat(StatList.distanceSwumStat, j);
+                if (dimension == Dimension.nether.id) {
+                    addStat(Achievements.SWIM_NETHER, 1);
+                }
             }
         } else
         if(canClimb())
diff --git a/src/main/java/net/minecraft/core/entity/projectile/ArrowProjectile.java b/src/main/java/net/minecraft/core/entity/projectile/ArrowProjectile.java
index dba79c5c7..13cd620fc 100644
--- a/src/main/java/net/minecraft/core/entity/projectile/ArrowProjectile.java
+++ b/src/main/java/net/minecraft/core/entity/projectile/ArrowProjectile.java
@@ -1,6 +1,8 @@
 package net.minecraft.core.entity.projectile;
 
 import com.mojang.nbt.CompoundTag;
+import net.minecraft.core.achievement.Achievement;
+import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.phys.HitResult;
@@ -24,6 +26,7 @@ public class ArrowProjectile extends Projectile
     public static final int TYPE_NORMAL = 0;
     public static final int TYPE_PURPLE = 1;
     public static final int TYPE_GOLDEN = 2;
+    protected int mobsHit = 0;
     protected int xTile = -1;
     protected int yTile = -1;
     protected int zTile = -1;
@@ -150,7 +153,7 @@ public class ArrowProjectile extends Projectile
             }
             return;
         }
-        else if(this instanceof ArrowProjectileGolden)
+        else if(this instanceof GoldenArrowProjectile)
         {
             world.spawnParticle("arrowtrail", x, y, z, xd * 0.05D, yd * 0.05D - 0.1D, zd * 0.05D, 0);
             world.spawnParticle("arrowtrail", x + xd * 0.5D, y + yd * 0.5D, z + zd * 0.5D, xd * 0.05D, yd * 0.05D - 0.1D, zd * 0.05D, 0);
@@ -172,11 +175,15 @@ public class ArrowProjectile extends Projectile
                 if(!world.isClientSide) {
                 	world.playSoundAtEntity(null, this, "random.drr", 1.0F, 1.2F / (random.nextFloat() * 0.2F + 0.9F));
                 }
-                if(!(this instanceof ArrowProjectileGolden))
+                if(!(this instanceof GoldenArrowProjectile))
                 {
                     remove();
+                } else {
+                    if (owner instanceof Player && ++mobsHit >= 3) {
+                        ((Player) owner).addStat(Achievements.TRIPLE_HIT, 1);
+                    }
                 }
-            } else if(!(this instanceof ArrowProjectileGolden))
+            } else if(!(this instanceof GoldenArrowProjectile))
             {
                 xd *= -0.1D;
                 yd *= -0.1D;
diff --git a/src/main/java/net/minecraft/core/entity/projectile/FireballProjectile.java b/src/main/java/net/minecraft/core/entity/projectile/FireballProjectile.java
index 940c52802..55d1fae8e 100644
--- a/src/main/java/net/minecraft/core/entity/projectile/FireballProjectile.java
+++ b/src/main/java/net/minecraft/core/entity/projectile/FireballProjectile.java
@@ -1,7 +1,9 @@
 package net.minecraft.core.entity.projectile;
 
+import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.monster.GhastMob;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.entity.Entity;
@@ -87,6 +89,9 @@ public class FireballProjectile extends Projectile
                     } else {
                         result.entity.hurt(owner, damage, DamageType.COMBAT);
                     }
+                    if (owner instanceof Player) {
+                        ((Player) owner).addStat(Achievements.HIT_FIREBALL, 1);
+                    }
                 }
                 world.newExplosion(owner, x, y, z, 1.5F, true, false);
             }
diff --git a/src/main/java/net/minecraft/core/entity/projectile/ArrowProjectileGolden.java b/src/main/java/net/minecraft/core/entity/projectile/GoldenArrowProjectile.java
similarity index 83%
rename from src/main/java/net/minecraft/core/entity/projectile/ArrowProjectileGolden.java
rename to src/main/java/net/minecraft/core/entity/projectile/GoldenArrowProjectile.java
index b22d2d99a..a16b3ad88 100644
--- a/src/main/java/net/minecraft/core/entity/projectile/ArrowProjectileGolden.java
+++ b/src/main/java/net/minecraft/core/entity/projectile/GoldenArrowProjectile.java
@@ -8,29 +8,28 @@ package net.minecraft.core.entity.projectile;
 
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.item.Item;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
 
-public class ArrowProjectileGolden extends ArrowProjectile
+public class GoldenArrowProjectile extends ArrowProjectile
 {
 
-    public ArrowProjectileGolden(World world)
+    public GoldenArrowProjectile(World world)
     {
         super(world, TYPE_GOLDEN);
         this.noPhysics = true;
         stack = new ItemStack(Items.AMMO_ARROW_GOLD);
     }
 
-    public ArrowProjectileGolden(World world, double x, double y, double z)
+    public GoldenArrowProjectile(World world, double x, double y, double z)
     {
         super(world, x, y, z, TYPE_GOLDEN);
         this.noPhysics = true;
         stack = new ItemStack(Items.AMMO_ARROW_GOLD);
     }
 
-    public ArrowProjectileGolden(World world, Mob owner, boolean doesArrowBelongToPlayer)
+    public GoldenArrowProjectile(World world, Mob owner, boolean doesArrowBelongToPlayer)
     {
         super(world, owner, doesArrowBelongToPlayer, TYPE_GOLDEN);
         this.noPhysics = true;
diff --git a/src/main/java/net/minecraft/core/entity/projectile/ArrowProjectilePurple.java b/src/main/java/net/minecraft/core/entity/projectile/PurpleArrowProjectile.java
similarity index 81%
rename from src/main/java/net/minecraft/core/entity/projectile/ArrowProjectilePurple.java
rename to src/main/java/net/minecraft/core/entity/projectile/PurpleArrowProjectile.java
index f53610c9d..ce9c9780e 100644
--- a/src/main/java/net/minecraft/core/entity/projectile/ArrowProjectilePurple.java
+++ b/src/main/java/net/minecraft/core/entity/projectile/PurpleArrowProjectile.java
@@ -1,7 +1,6 @@
 package net.minecraft.core.entity.projectile;
 
 import net.minecraft.core.entity.Mob;
-import net.minecraft.core.item.Item;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.world.World;
 
@@ -11,20 +10,20 @@ import net.minecraft.core.world.World;
 //            MovingObjectPosition, NBTTagCompound, ItemStack, Item, 
 //            InventoryPlayer
 
-public class ArrowProjectilePurple extends ArrowProjectile
+public class PurpleArrowProjectile extends ArrowProjectile
 {
 
-    public ArrowProjectilePurple(World world)
+    public PurpleArrowProjectile(World world)
     {
         super(world, TYPE_PURPLE);
     }
 
-    public ArrowProjectilePurple(World world, double x, double y, double z)
+    public PurpleArrowProjectile(World world, double x, double y, double z)
     {
         super(world, x, y, z, TYPE_PURPLE);
     }
 
-    public ArrowProjectilePurple(World world, Mob owner, boolean doesArrowBelongToPlayer)
+    public PurpleArrowProjectile(World world, Mob owner, boolean doesArrowBelongToPlayer)
     {
         super(world, owner, doesArrowBelongToPlayer, TYPE_PURPLE);
     }
